//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "acAppStartCounter"
#pragma link "acClasses"
#pragma link "acFormPlacementSaver"
#pragma link "acHTTP"
#pragma link "acMRUComboBox"
#pragma link "acStatusControl"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GOBtnClick(TObject *Sender)
{
  acHTTP1->URL = URLCombo->Text;
  acHTTP1->POSTData = POSTEdit->Text;
  acHTTP1->Read();

  Memo1->Clear();
  ProgressBar1->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::STOPBtnClick(TObject *Sender)
{
  acHTTP1->Abort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::acHTTP1Aborted(TObject *Sender)
{
  StatusBar1->Panels->Items[0]->Text = "Connection aborted by user";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::acHTTP1ConnLost(TObject *Sender,
      AnsiString ContentType, int FileSize, int BytesRead, TStream *Stream)
{
  StatusBar1->Panels->Items[0]->Text = "Connection with remote host lost";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::acHTTP1Done(TObject *Sender,
      AnsiString ContentType, int FileSize, TStream *Stream)
{
  AnsiString Str;

  if (Out1->Checked) {
    Str.SetLength(Stream->Size);
    Move(((TMemoryStream*)Stream)->Memory, &Str[1], Stream->Size);
    Memo1->Text = Str;
  }else {
    Memo1->Text = "Saved to c:\httptest.dat";
    ((TMemoryStream*)Stream)->SaveToFile("c:\httptest.dat");
  }

  StatusBar1->Panels->Items[0]->Text = "Successfully downloaded " + IntToStr(FileSize) + " bytes";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::acHTTP1HostUnreachable(TObject *Sender)
{
  StatusBar1->Panels->Items[0]->Text = "Host unrechable";        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::acHTTP1HTTPError(TObject *Sender, int ErrorCode,
      TStream *Stream)
{
  AnsiString Str;

  if (Out1->Checked) {
    Str.SetLength(Stream->Size);
    Move(((TMemoryStream*)Stream)->Memory, &Str[1], Stream->Size);
    Memo1->Text = Str;
  }else {
    Memo1->Text = "Saved to c:\httptest.dat";
    ((TMemoryStream*)Stream)->SaveToFile("c:\httptest.dat");
  }

  switch (ErrorCode) {
    case 404: Str = "404: Document not found";
    case 500: Str = "500: CGI script failed";
    default:  Str = IntToStr(ErrorCode);
  };

  StatusBar1->Panels->Items[0]->Text = "HTTP Error #" + Str;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::acHTTP1PasswordRequest(TObject *Sender,
      bool &TryAgain)
{
  StatusBar1->Panels->Items[0]->Text = "Password protected site";  

// implement dialog which asks the username/password here
// acHTTP1->Username = AskUsername;
// acHTTP1->Password = AskPassword;
// TryAgain = True;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::acHTTP1Progress(TObject *Sender,
      AnsiString ContentType, int FileSize, int BytesRead, int ElapsedTime,
      int EstimatedTimeLeft, BYTE PercentsDone, float TransferRate,
      TStream *Stream)
{
  ProgressBar1->Position = PercentsDone;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::acAppStartCounter1FirstStart(TObject *Sender)
{
  URLCombo->Items->Add("http://www.appcontrols.com/cgi/test/http_test1.cgi");        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
  URLCombo->Width = ClientWidth - 133;        
}
//---------------------------------------------------------------------------
